/* Cov_IVM.c */
#include <math.h>
#include "mex.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    
    // Get the input
    double *Voted_count, *alpha_x, *alpha_y, *Voted_count_result;
    mxLogical *Gra_mag_Bi;
    double *Gra_mag_gray;
    int r_max, r_min;
    double delta;
    int n_height, n_width;
    double sigma;
    double r, theta, weight_A;
    int m, n, i, j, m_off, n_off, m_A, n_A;
    double dot;
    double Gra_mag_now;
    
    if (nrhs != 8 || nlhs != 1)
    {
        mexErrMsgTxt("Wrong number of inputs or outputs!\n");
    }
    
//     for( i = 0; i < 8; i ++)
//     {
//         mexPrintf("%d\n", mxGetClassID(prhs[i]));
//     }
    
    Voted_count = mxGetPr(prhs[0]);
    Gra_mag_Bi = mxGetLogicals(prhs[1]);
    Gra_mag_gray = mxGetPr(prhs[2]);
    alpha_x = mxGetPr(prhs[3]);
    alpha_y = mxGetPr(prhs[4]);
    
    r_max = (int)(*mxGetPr(prhs[5]));
    r_min = (int)(*mxGetPr(prhs[6]));
    delta = *(mxGetPr(prhs[7]));
    // mexPrintf("%d %d\n", r_max, r_min);
    
    n_height = mxGetM(prhs[0]);
    n_width = mxGetN(prhs[0]);
    // mexPrintf("%d %d\n", n_height, n_width);
    
    plhs[0] = mxDuplicateArray(prhs[0]);
    Voted_count_result = mxGetPr(plhs[0]);
    
    sigma = delta;
    // mexPrintf("%f\n", sigma)
    
    for (n = 0; n < n_width; n ++){
        for (m = 0; m < n_height; m ++){
            
            // mexPrintf("%d\n", *(Gra_mag_Bi + m * n_width + n));
            if (*(Gra_mag_Bi + m + n * n_height) == 0)
                continue;
            Gra_mag_now = *(Gra_mag_gray + m + n * n_height);
            
            for (n_off = -r_max; n_off <= r_max; n_off ++){
                
                n_A = n + n_off;
                if (n_A < 0 || n_A > n_width - 1)
                    continue;
                
                
                for (m_off = -r_max; m_off <= r_max; m_off ++){
                    
                    if (m_off == 0 && n_off == 0)
                        continue;
                    
                    
                    m_A = m + m_off;
                    if (m_A < 0 || m_A > n_height - 1)
                        continue;
                    
                    
                    r = sqrt((double)(m_off * m_off + n_off * n_off));
                    if (r > r_max || r < r_min)
                        continue;
                    
                    dot = (double)(m_off * *(alpha_y + m  + n * n_height) + n_off * *(alpha_x + m + n * n_height)) / r;
                    if (dot > 1.0)
                        dot = 1.0;
                    if (dot < -1.0)
                        dot = -1.0;
                    theta = acos(dot);
                    
                    if (theta > delta)
                        continue;
                    
                    weight_A = exp(- theta * theta / sigma / sigma);
                    
                    *(Voted_count_result + m_A + n_A * n_height) += weight_A * Gra_mag_now;        
                }
            }
        }       
    }     
}