function [Voted_count] = Cov_IVM_m(Voted_count, Gra_mag_Bi, Gra_mag_gray, alpha_x, alpha_y, r_max, r_min, delta)

[n_height n_width] = size(Voted_count);

sigma = delta;
for m = 1:n_height
    for n = 1:n_width
        if Gra_mag_Bi(m, n) == 0
            continue;
        end
        
        Gra_mag_now = Gra_mag_gray(m, n);
        
        
        for m_off = -r_max:r_max
            
            m_A = m + m_off;
            if m_A < 1 || m_A > n_height
                continue;
            end
            
            for n_off = -r_max:r_max
                
                if m_off == 0 && n_off == 0
                    continue
                end
                
                n_A = n + n_off;
                if n_A < 1 || n_A > n_width
                    continue;
                end
                
                r = sqrt(m_off * m_off + n_off * n_off);
                if r > r_max || r < r_min
                    continue;
                end
                
                theta = acos((m_off * alpha_y(m, n) + n_off * alpha_x(m, n)) / sqrt(m_off * m_off + n_off * n_off));
                
                if theta > delta
                    continue;
                end
                
                weight_A = exp(-theta * theta / sigma / sigma);
                Voted_count(m_A, n_A) = Voted_count(m_A, n_A) + Gra_mag_now * weight_A;
                
            end
        end
    end
end