function [Voted_center] = Iterative_Voting(Image_filtered, dia_particle)

[n_height_or n_width_or] = size(Image_filtered);
dia_particle_or = dia_particle;

% resize
scale = 1.0;
Image_filtered = imresize(Image_filtered, scale);
dia_particle = dia_particle * scale;

thre_gra = 0.2;

[n_height n_width] = size(Image_filtered);
Voted_count = zeros(n_height, n_width);

% Calculate the gradiant
h_range = ceil(dia_particle / 8.0);
h_size = h_range * 2 + 1;
h_x_gra = [-ones(h_size, h_range) zeros(h_size, 1) ones(h_size, h_range)];
h_y_gra = h_x_gra';

Image_filtered = double(Image_filtered);
Gra_x = imfilter(Image_filtered, h_x_gra, 'replicate');
Gra_y = imfilter(Image_filtered, h_y_gra, 'replicate');

Gra_mag = sqrt(Gra_x.^2 + Gra_y.^2);
Gra_mag_gray = mat2gray(Gra_mag);

Gra_mag_Bi = Gra_mag_gray > thre_gra;
% imshow(uint8(Gra_mag_Bi .* 255))
% return;

% imwrite(uint8(Gra_mag_Bi .* Gra_mag_gray .* 255), 'vote.jpg')
% return;

Gra_mag  = Gra_mag .* Gra_mag_Bi;
alpha_x = - Gra_x .* Gra_mag_Bi ./ (Gra_mag + (Gra_mag_Bi == 0));
alpha_y = - Gra_y .* Gra_mag_Bi ./ (Gra_mag + (Gra_mag_Bi == 0));

r_min = floor(dia_particle / 5);
r_max = floor(dia_particle / 2);
delta = pi / 6;



% Initilization

% Compare and test two kinds of code
% tic;
% Voted_count_1 = Cov_IVM(Voted_count, Gra_mag_Bi, Gra_mag_gray, alpha_x, alpha_y, r_max, r_min, delta);
% toc;
% tic;
% Voted_count_2 = Cov_IVM_m(Voted_count, Gra_mag_Bi, Gra_mag_gray, alpha_x, alpha_y, r_max, r_min, delta);
% toc;
% sum(sum(abs(Voted_count_1 - Voted_count_2)))
% return;

Voted_count = Cov_IVM(Voted_count, Gra_mag_Bi, Gra_mag_gray, alpha_x, alpha_y, r_max, r_min, delta);
%Voted_count = Cov_IVM_m(Voted_count, Gra_mag_Bi, Gra_mag_gray, alpha_x, alpha_y, r_max, r_min, delta);

while delta > pi / 36
    %Updata alpha
    %test
%     tic;
%     [alpha_x_1, alpha_y_1] = Update_alpha_IVM(Voted_count, Gra_mag_Bi, r_max, r_min, delta);
%     toc;
%     tic;
%     [alpha_x_2, alpha_y_2] = Update_alpha_IVM_m(Voted_count, Gra_mag_Bi, r_max, r_min, delta);
%     toc;
%     sum(sum(abs(alpha_x_1 - alpha_x_2)))
%     sum(sum(abs(alpha_y_1 - alpha_y_2)))
%    return;
    
    [alpha_x, alpha_y] = Update_alpha_IVM(Voted_count, Gra_mag_Bi, r_max, r_min, delta);
    %[alpha_x, alpha_y] = Update_alpha_IVM_m(Voted_count, Gra_mag_Bi, r_max, r_min, delta);
   
    
    % Vote again
    delta = delta / 2.0;
    
    Voted_count = Cov_IVM(Voted_count, Gra_mag_Bi, Gra_mag_gray, alpha_x, alpha_y, r_max, r_min, delta);
    %Voted_count = Cov_IVM_m(Voted_count, Gra_mag_Bi, Gra_mag_gray, alpha_x, alpha_y, r_max, r_min, delta);
end
    

Voted_count_or = imresize(Voted_count, [n_height_or, n_width_or]);

Voted_max = max(max(Voted_count_or));
Voted_thre = 0.1;

Voted_count_or = Voted_count_or .* (Voted_count_or > (Voted_max * Voted_thre));

Voted_center = imregionalmax(Voted_count_or,8);
Local_range = round(double(dia_particle_or) / 2.0);

for i = 1:n_height
    for j = 1:n_width
        if Voted_center(i, j) == 0
            continue;
        end
        
        i_begin = max(1, i - Local_range);
        j_begin = max(1, j - Local_range);
        i_end = min(n_height, i + Local_range);
        j_end = min(n_width, j + Local_range);
        
        if Voted_count_or(i, j) < max(max(Voted_count_or(i_begin:i_end, j_begin:j_end)))
            Voted_center(i, j) = 0;
        end
    end
end
