/* Update_alpha_IVM.c */
#include <math.h>
#include "mex.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    // Get the input
    double *Voted_count, *alpha_x, *alpha_y, *Voted_count_result;
    mxLogical *Gra_mag_Bi;
    double *Gra_mag_gray;
    int r_max, r_min;
    double delta;
    int n_height, n_width;
    double sigma;
    double r, theta;
    int m, n, i, j, m_off, n_off, m_A, n_A;
    double dot;
    double Gra_mag_now;
    double max_vote;
    int max_m_off, max_n_off;
    
    if (nrhs != 5 || nlhs != 2)
    {
        mexErrMsgTxt("Wrong number of inputs or outputs!\n");
    }
    Voted_count = mxGetPr(prhs[0]);
    Gra_mag_Bi = mxGetLogicals(prhs[1]);
    r_max = (int)(*mxGetPr(prhs[2]));
    r_min = (int)(*mxGetPr(prhs[3]));
    delta = *(mxGetPr(prhs[4]));
    
    sigma = delta;
    
    n_height = mxGetM(prhs[0]);
    n_width = mxGetN(prhs[0]);
    
    plhs[0] = mxCreateDoubleMatrix(n_height, n_width, mxREAL);
    plhs[1] = mxCreateDoubleMatrix(n_height, n_width, mxREAL);
    alpha_x = mxGetPr(plhs[0]);
    alpha_y = mxGetPr(plhs[1]);
    
    for (n = 0; n < n_width; n ++){
        for (m = 0; m < n_height; m ++){
            *(alpha_x + m + n * n_height) = 0;
            *(alpha_y + m + n * n_height) = 0;
        }
    }
    
    for (n = 0; n < n_width; n ++){
        for (m = 0; m < n_height; m ++){
            
            // mexPrintf("%d\n", *(Gra_mag_Bi + m * n_width + n));
            if (*(Gra_mag_Bi + m + n * n_height) == 0)
                continue;
            
            max_vote = -1;
            
            for (n_off = -r_max; n_off <= r_max; n_off ++){
                
                n_A = n + n_off;
                if (n_A < 0 || n_A > n_width - 1)
                    continue;
                
                
                for (m_off = -r_max; m_off <= r_max; m_off ++){
                    
                    if (m_off == 0 && n_off == 0)
                        continue;
                    
                    
                    m_A = m + m_off;
                    if (m_A < 0 || m_A > n_height - 1)
                        continue;
                    
                    
                    r = sqrt((double)(m_off * m_off + n_off * n_off));
                    if (r > r_max || r < r_min)
                        continue;
                    
                    dot = (double)(m_off * *(alpha_y + m  + n * n_height) + n_off * *(alpha_x + m + n * n_height)) / r;
                    if (dot > 1.0)
                        dot = 1.0;
                    if (dot < -1.0)
                        dot = -1.0;
                    theta = acos(dot);
                    
                    if (theta > delta)
                        continue;
                    
                    if (max_vote < *(Voted_count + m_A + n_A * n_height)){
                        max_vote = *(Voted_count + m_A + n_A * n_height);
                        max_m_off = m_off;
                        max_n_off = n_off;
                    }
                }
            }
            
            if (max_vote > 0){
                *(alpha_x + m + n * n_height) =  max_n_off / sqrt(max_m_off * max_m_off + max_n_off * max_n_off);
                *(alpha_y + m + n * n_height) =  max_m_off / sqrt(max_m_off * max_m_off + max_n_off * max_n_off);
            }
        }
    }
    
    
}