function [alpha_x, alpha_y] = Update_alpha_IVM_m(Voted_count, Gra_mag_Bi, r_max, r_min, delta)

[n_height n_width] = size(Gra_mag_Bi);

    alpha_x = 0 .* Gra_mag_Bi;
    alpha_y = 0 .* Gra_mag_Bi;
    
    for m = 1:n_height
        for n = 1:n_width
            if Gra_mag_Bi(m, n) == 0
                continue;
            end
            
            max_vote = -1;
            for m_off = -r_max:r_max
                
                m_A = m + m_off;
                if m_A < 1 || m_A > n_height
                    continue;
                end
                
                for n_off = -r_max:r_max
                    
                    if m_off == 0 && n_off == 0
                        continue
                    end
                    
                    n_A = n + n_off;
                    if n_A < 1 || n_A > n_width
                        continue;
                    end
                    
                    r = sqrt(m_off * m_off + n_off * n_off);
                    if r > r_max || r < r_min
                        continue;
                    end
                    
                    theta = acos((m_off * alpha_y(m, n) + n_off * alpha_x(m, n)) / sqrt(m_off * m_off + n_off * n_off));
                    
                    if theta > delta
                        continue;
                    end
                    
                    if max_vote < Voted_count(m_A, n_A)
                        max_vote = Voted_count(m_A, n_A);
                        max_m_off = m_off;
                        max_n_off = n_off;
                    end
                    
                end
            end
            
            if max_vote > 0
                alpha_x(m, n) =  max_n_off / sqrt(max_m_off * max_m_off + max_n_off * max_n_off);
                alpha_y(m, n) =  max_m_off / sqrt(max_m_off * max_m_off + max_n_off * max_n_off);
            end
        end
    end