function [centroids] = get_atomic_locations(Raw_image)

if ndims(Raw_image) > 2
    Raw_image = rgb2gray(Raw_image);
end
[nx, ny] = size(Raw_image);

gx = nx / 128;
gy = ny / 128;
dia_particle = 10;

%imshow(Raw_image);
%hold on;
centroids = [];
for k = 1:ceil(gx)
    for l = 1:ceil(gy)
        
        rx = (k-1)*128 + 1; ry = (l-1)*128+1;
        mx = max((k-1)*128-7, 1); Mx = min(k*128+8, nx);
        my = max((l-1)*128-7, 1); My = min(l*128+8, ny);
        Img = Raw_image(mx:Mx, my:My);
        centroids_kl = getAtomColumns(256-Img, dia_particle);
        
        centroids_kl= centroids_kl(centroids_kl(:, 1) >= ry-my+1 & centroids_kl(:, 1) <= 128+ry-my & centroids_kl(:, 2) >= rx-mx+1 & centroids_kl(:, 2) <= 128 + rx-mx, :);
        
        centroids_kl(:, 1) = centroids_kl(:, 1) + my - 1;
        centroids_kl(:, 2) = centroids_kl(:, 2) + mx - 1;
        centroids = [centroids; centroids_kl];
    end
end

%imshow(Raw_image);
%hold on;
%scatter(centroids(:,1), centroids(:,2), 'r.');
%hold off;

%csvwrite('D10 HADF-10299 output.csv', centroids);
%save('D10 HADF-10299 output.mat', 'centroids');