function [v1, v2, tau] = group_selection(img_noise)
             
I = img_noise;
F1 = fft2(I);
F2 = fft2(abs(F1).^2);

% subplot(1,2,1); imagesc(I); colormap('gray'); axis off; title('(a) Original Image');
% [centroids] = getAtomColumns(max(I(:)) - I, 5);
% hold on;
% scatter(centroids(:, 2), centroids(:, 1), 'ro');
% hold off;

%imagesc(log(abs(fftshift(F2)))); colormap('gray'); axis off; title('(b) Double Fourier Transformed Image');
y = log(abs(fftshift(F2)));
cpt = round(size(y)/2); mg = [min(100, cpt(1)-1), min(100, cpt(2)-1)]; 
y = y(cpt(1)-mg(1):cpt(1)+mg(1), cpt(2)-mg(2):cpt(2)+mg(2));
[centroids] = get_atomic_locations(y);
imagesc(y); colormap('gray'); axis off;
 hold on;
scatter(centroids(:, 1), centroids(:, 2), 'ro');
hold off;

n = size(centroids, 1);
D = centroids - repmat(mean(centroids), n, 1);

% initial 
d = sum(D.^2, 2);
[~, id] = min(d); mask = (1:size(centroids, 1)) == id;
D = centroids(~mask, :) - ones(n-1, 1) * centroids(mask, :);
diff = D(:, 1).^2 + D(:, 2).^2;
[~, id2] = min(diff);
v1 = D(id2, :); v1 = sign(v1(1))*v1;

x1 = centroids(mask, :) - v1;
x2 = centroids(mask, :) + v1;
D1 = pdist2(centroids(~mask, :), [x1; x2]);
[~, id3] = min(D1);
id4 = setdiff(1:size(D1, 1), id3);
D2 = D(id4, :);
[~, id5] = min(sum(D2.^2, 2));
v2 = D2(id5, :); v2 = sign(v2(1))*v2;

% Below is the optimization
V = [v1; v2];
A  = (V*V') \ V * D'; A = A';
dd = A - round(A); idx = sum(dd.^2, 2) < 5e-2;
%scatter(D(idx, 1), D(idx, 2));
%hold on;
%ee = round(A(idx, :)) * V;
%scatter(ee(:, 1), ee(:, 2), '+');
%hold off;

Ax = round(A(idx, :)); Dx = D(idx, :);
Vx = (Ax'*Ax)\Ax'*Dx;
v1 = Vx(1, :);
v2 = Vx(2, :);


cpt = centroids(mask, :);
f = y(cpt(2), cpt(1):cpt(1)+10);
x = 0:length(f)-1;   f = f - min(f) + 1e-5; f = f/norm(f);
s = 0.5:0.5:10;
for k = 1:length(s)
    fe = normpdf(x, 0, s(k));
    fe = fe - min(fe) + 1e-5; fe = fe/norm(fe);
    dst(k) = mean((f - fe).^2);
end

[~, k] = min(dst);
tau = s(k);
