% Code_Figure6_10 - The code generates Figure 6.10 and Figure 6.11 of the book 
%                   'Data Science for Nano Image Analysis'
%                  written by Chiwoo Park and Yu Ding, 2021, Springer
%                  Nature 
%                
%               - implement  Section 4.2.2 of the book.
%
% Copyright ©2020 reserved to Chiwoo Park (cpark5@fsu.edu) 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [FPS_dis, FNS_dis, EXP_config] = test_with_synthetic_cases(V_num, Var_level, v_num_name, mode, rep_num, data_directory, result_directory)

load('./AOAS2018/True_lattice.mat'); %LP imagesize 75*75
load('./AOAS2018/B.mat')  % Basis matrix for full lattice grid

L  = chol(B'*B,'lower');  %L * L' = B2;
LB = L \ B';

P=length(LP(:,1));
void_search_grid=0:30;
p=length(void_search_grid);

cn=0;
for v=1:length(V_num)
    vn=V_num(v);
    
    for nn=1:length(Var_level)
        var_name = strcat('var_',sprintf('%02d',round(10*Var_level(nn)))); 
        for m=1:length(mode)
            cn=cn+1;
            FPS=[];
            FNS=[];
            for k=1:rep_num
               filename=strcat(data_directory, ...
                                char(v_num_name(v)),'-',...
                                char(var_name),'_',...
                                char(mode(m)),'_',...
                                sprintf('rep_%i',k),'_',...
                                'input_img.mat');
                            
               load(filename);
                   
               filename=strcat(data_directory, ...
                        char(v_num_name(v)),'-',...
                        char(var_name),'_',...
                        char(mode(m)),'_',...
                        sprintf('rep_%i',k),'_',...
                        'LP_void.mat');
                            
                  load(filename);
                  
               filename=strcat(data_directory, ...
                        char(v_num_name(v)),'-',...
                        char(var_name),'_',...
                        char(mode(m)),'_',...
                        sprintf('rep_%i',k),'_',...
                        'LP_atom.mat');
                            
               load(filename);
                  
               y=reshape(img_noise,[75*75,1]);
   
               c=y'*B;
               [c,sort_id]=sort(c,'descend');

               y_est=LB'*(LB*y);
               mse=(y-y_est)'*(y-y_est);
               S2=mse./(75*75-1);
               tr=sqrt(S2)*sqrt(2*log(P));
                   
               y_hat_series=[];
               y_hat_series(:,1)=y_est; 
               
               i = find(c > tr, 1, 'last');
               ind = sort_id(1:i);
%                for i=2:p
%                    ind=sort_id(1:P-void_search_grid(i));
%                    Li  = chol(B(:,ind)' * B(:,ind),'lower');  %L * L' = B2;
%                    LBi = Li \ B(:, ind)';
%                    y_hat_series(:,i)=LBi'* (LBi * y);
%                    del(i)=sqrt((y_hat_series(:,i)-y_hat_series(:,i-1))'*(y_hat_series(:,i)-y_hat_series(:,i-1)));
% 
%                    if del(i) > tr
%                       %break;
%                    end
%                end

               LP_atom_est=LP(ind,:);
%                imagesc(img_noise)
%                 colormap('gray')
%                 hold on;
%                 scatter(LP_atom_est(:,1), LP_atom_est(:, 2), 'ro')
%                 scatter(LP_atom(:,1), LP_atom(:, 2), 'b+')
%                 hold off;
               save(strcat(result_directory, ...
                            char(v_num_name(v)),'-',...
                            char(var_name),'_',...
                            char(mode(m)),'_',...
                            'Estimated_LP_atom','_',...
                            sprintf('rep_%i.mat',k)),'LP_atom_est');

               LP_void_est=setdiff(LP,LP_atom_est,'rows');
               save(strcat(result_directory, ...
                            char(v_num_name(v)),'-',...
                            char(var_name),'_',...
                            char(mode(m)),'_',...
                            'Estimated_LP_void','_',...
                            sprintf('rep_%i.mat',k)),'LP_void_est');

               FP_id=intersect(LP_void,LP_atom_est,'rows');
               save(strcat(result_directory, ...
                            char(v_num_name(v)),'-',...
                            char(var_name),'_',...
                            char(mode(m)),'_',...
                            'FP_id','_',...
                            sprintf('rep_%i.mat',k)),'FP_id');

               FN_id=intersect(LP_atom,LP_void_est,'rows');
               save(strcat(result_directory, ...
                            char(v_num_name(v)),'-',...
                            char(var_name),'_',...
                            char(mode(m)),'_',...
                            'FN_id','_',...
                            sprintf('rep_%i.mat',k)),'FN_id');

                FP=length(FP_id(:,1));
                save(strcat(result_directory, ...
                            char(v_num_name(v)),'-',...
                            char(var_name),'_',...
                            char(mode(m)),'_',...
                            'FP','_',...
                            sprintf('rep_%i.mat',k)),'FP');

               FN=length(FN_id(:,1));
               save(strcat(result_directory, ...
                           char(v_num_name(v)),'-',...
                           char(var_name),'_',...
                           char(mode(m)),'_',...
                           'FN','_',...
                           sprintf('rep_%i.mat',k)),'FN');

               FPS=[FPS,FP];
               FNS=[FNS,FN];
            end
            
            FPS_dis(cn,:)=FPS;
            FNS_dis(cn,:)=FNS;
            EXP_config(cn, :) = [v, nn, m];
        end
    end
end
