function [LP_atom_est] = thresholding_step(LP, tau, Raw_image)

[M, N] = size(Raw_image); 

% thresholding
P = size(LP, 1);
B = Construct_B( LP,M,N,tau);

%L  = chol(B'*B,'lower');  %L * L' = B2;
%LB = L \ B';

y = double(Raw_image(:)); y = y - mean(y(:)); y = y / std(y(:));
beta = 2*B'*y; % B is orthogonal
y_est = B * beta;
[~, sort_id] = sort(beta, 'descend');

del = zeros(size(B,2), 1);
for j = 1:size(B, 2)
    del(j) = sum(B(:, j).^2) * beta(j)^2;
end
del = sqrt(del);
plot(del(sort_id)); xlabel('j'); ylabel('Del(j)');
hold on;

mse=(y-y_est)'*(y-y_est);
S2=mse/(length(y(:))-1);
tr=sqrt(S2)*sqrt(2*log(P));
J   = find(del(sort_id) < tr, 1, 'first');% sum(del>tr);
plot([1, size(B, 2)], [tr tr], 'r-.', 'LineWidth', 2);
hold off;

LP_atom_est=LP(sort_id(1:J),:);