
addpath(genpath('./AOAS2018'));
Raw_image = imread('./images/B5- HAADF-32777.tif');
if ndims(Raw_image) > 2
    Raw_image = rgb2gray(Raw_image);
end

Raw_image = Raw_image(900:1100, 900:1100);

% get lattice basis and point spreading function
[v1, v2, tau] = group_selection(Raw_image);
tau = tau / sqrt(2);
[M, N] = size(Raw_image);

% get basis locations
[LP] = estimate_s(Raw_image, v1, v2, tau);

% thresholding
subplot(2,1,2);
[LP_atom_est] = thresholding_step(LP, tau, Raw_image);

subplot(2,1,1);
imagesc(Raw_image); axis off; colormap('gray');
hold on;
%scatter(LP(:, 1), LP(:, 2), 'k+');
scatter(LP_atom_est(:, 1), LP_atom_est(:, 2), 50, 'm', 'LineWidth', 3);
hold off;
